/*
======================================================
====      Java Classes For Genetic Algorithms     ====
==== (c) Marek Obitko, 1998-1999, obitko@email.cz ====
======================================================

This file is a part of Java library for genetic algorithms with 
visualization. You may use this library or its part free of charge
provided you acknowledge the author (Marek Obitko), and the source 
(Learning Environment for Genetic Algorithms, one of the URLs 
below) in your work where you use it (contact the author, if you 
are in doubt). Moreover I would appreciate if you inform me 
(via email) about your work where you used it 
(this is not compulsory).

THIS LIBRARY IS PROVIDED "AS IS", WITHOUT ANY WARRANTY.

This package was designed for learning environment for GAs, see
http://cs.felk.cvut.cz/~xobitko/ga  or

Author is studying Czech Technical University in Prague, 
Faculty of Electrical Engineering, Department of Computer Engineering.
Major part of this library was written at University of Applied Sciency
in Dresden, Germany.
*/


/** Defines function of which the minimum is looked for in genetic algorithm.
  * Change this function to work on other one.
  * <p>
  * Enables parsing expression in a string.
  * @see Graph3DCanvas
  * <p>
  * @author Marek Obitko, <A HREF="mailto:obitko@email.cz">obitko@email.cz</A>
  * @version 1.0
  */
public class Function3D
{

  /** Expression string. */
  protected static String exprStr;
  
  /** Expression */
  protected static Expression expr;
  
  /** What will be returned. */
  public static int returnType=0;
  
  public static final int returnBasic=0;
  public static final int returnParsed=1;
  public static final int returnStatic1=2;

  /** Was there any error? (e.g. in parsing.) */
  public static boolean wasError=false;
  
  /** Returns value of the function. */
  public static synchronized double value(double x, double y)
  {
    switch(returnType)
      {
        case returnParsed: 
              try { return expr.value(x,y); }
              catch (ArithmeticException e) 
                 { 
                    wasError=true;
                    returnType=returnBasic; 
                    return value(x,y);
                 }
        case returnStatic1: 
              return Math.sin(x/20)*20+Math.cos(y/40)*40;
      }
    return 0; // returnBasic
  }
  
  /** Parses funtion from String. If successfull, value of this function will
    * be returned. */
  public static synchronized void parseFunction(String aFunction)
  {
    exprStr=aFunction;
    returnType=returnParsed;
    wasError=false;
    try
     {
        expr=new Expression(exprStr);
     } catch (ParseError e) { 
                              returnType=returnBasic;
                              wasError=true;
                            }
       catch (ArithmeticException e) { 
                                       returnType=returnBasic;
                                       wasError=true;
                                     }
  }
}