/*
======================================================
====      Java Classes For Genetic Algorithms     ====
==== (c) Marek Obitko, 1998-1999, obitko@email.cz ====
======================================================

This file is a part of Java library for genetic algorithms with 
visualization. You may use this library or its part free of charge
provided you acknowledge the author (Marek Obitko), and the source 
(Learning Environment for Genetic Algorithms, one of the URLs 
below) in your work where you use it (contact the author, if you 
are in doubt). Moreover I would appreciate if you inform me 
(via email) about your work where you used it 
(this is not compulsory).

THIS LIBRARY IS PROVIDED "AS IS", WITHOUT ANY WARRANTY.

This package was designed for learning environment for GAs, see
http://cs.felk.cvut.cz/~xobitko/ga  or

Author is studying Czech Technical University in Prague, 
Faculty of Electrical Engineering, Department of Computer Engineering.
Major part of this library was written at University of Applied Sciency
in Dresden, Germany.
*/


import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

/** Class for running applets without browser or appletviewer.
  * <p> It adds frame and menu for exiting the application (the applet).
  * <p> It is called when the applet is run as a class directly.
  * <p>
  * @author Marek Obitko, <A HREF="mailto:obitko@email.cz">obitko@email.cz</A>
  * @version 1.0
  */
public class GAApplication extends Frame
{
  /** Makes window and runs the applet.
    * @param title title of the window
    * @param applet applet which should be run
    * @param x width of the window
    * @param y height of the window
    */
  public GAApplication(String title, Applet applet, int x, int y)
  {
    super(title);

    MenuBar menubar = new MenuBar();
    Menu file = new Menu("Application", true);
    menubar.add(file);
    file.add("Exit");
    this.setMenuBar(menubar);

    this.add("Center", applet);
    this.setSize(x, y);
    this.show();

    applet.init();
    applet.start();
  }

  /** Handles menu of window. Used for exiting application.*/
  public boolean action(Event e, Object arg)
  {
    if (e.target instanceof MenuItem)
    {
      String label = (String) arg;
      if (label.equals("Exit")) System.exit(0);
    }
    return false;
  }
}